#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_BulletCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_BulletCFG> Fish_BulletCFG::msSingleton(nullptr);

int Fish_BulletCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_BulletCFGData* Fish_BulletCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_BulletCFGData>& Fish_BulletCFG::GetMapData()
{
	return mMapData;
}

void Fish_BulletCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_BulletCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_BulletCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mBulletType = element->IntAttribute("BulletType");
		data.mResType = element->IntAttribute("ResType");
		data.mResName = element->Attribute("ResName");
		data.mColor = element->IntAttribute("Color");
		data.mScale = element->FloatAttribute("Scale");
		{
			const char* Collider = element->Attribute("Collider");
			std::vector<std::string> vecCollider;
			boost::split(vecCollider, Collider, boost::is_any_of(","));
			float temp;
			for (unsigned int i = 0; i < vecCollider.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToFloat(vecCollider[i].c_str(), &temp))
				{
					data.mCollider.push_back(temp);
				}
			}
		}
		data.mBulletCount = element->IntAttribute("BulletCount");
		data.mHitType = element->IntAttribute("HitType");
		data.mHitEffectID = element->IntAttribute("HitEffectID");
		data.mHitSoundID = element->IntAttribute("HitSoundID");
		data.mNetEffect = element->IntAttribute("NetEffect");
		data.mNetSize = element->IntAttribute("NetSize");
		data.mNetScale = element->FloatAttribute("NetScale");
		data.mNetCount = element->IntAttribute("NetCount");
		data.mNetHitCount = element->IntAttribute("NetHitCount");
		data.mSpeed = element->IntAttribute("Speed");
		{
			const char* Param = element->Attribute("Param");
			std::vector<std::string> vecParam;
			boost::split(vecParam, Param, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecParam[i].c_str(), &temp))
				{
					data.mParam.push_back(temp);
				}
			}
		}
		data.mRadius = element->FloatAttribute("Radius");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_BulletCFG::Load()
{
	Load("../Config/Fish_BulletCFG.xml");
}

Fish_BulletCFG* Fish_BulletCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_BulletCFG());
	}
	return msSingleton.get();
}
